package com.iamberry.wechat.handles.mothMovable;

import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.WechatUtils;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.mothMovable.MothMovable;
import com.iamberry.wechat.core.entity.stati.AcceStatistics;
import com.iamberry.wechat.face.member.MemberService;
import com.iamberry.wechat.face.mothMovable.MothMovableService;
import com.iamberry.wechat.face.stati.AcceStatisticsService;
import com.iamberry.wechat.tools.ResultInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;

/**
 * xm
 * 母亲节活动
 * @Date 2019
 */
@Controller
@RequestMapping("/wechat/moth_movable")
public class MothMovableHandler {
    private final static String ENCODE = "utf-8";

    @Autowired
    private MothMovableService mothMovableService;
    @Autowired
    private MemberService memberService;
    @Autowired
    private AcceStatisticsService acceStatisticsService;

    /**
     * 获取二维码
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/save_movable", method = RequestMethod.POST)
    public ResultMsg saveMvable( HttpServletResponse response,HttpServletRequest request,MothMovable mothMovable) throws Exception {
        long x = System.currentTimeMillis();
        ResultMsg msg = new ResultMsg();

        Member member = WechatUtils.getUserBySession(request);
        member = memberService.getMemberByUserOpenId(member.getUserOpenid());

        if(mothMovable.getMothMovaBackType() == null){
            return new ResultMsg(false,  ResultMsg.ERROR, "未选择背景图片",null);
        }

        if(mothMovable.getMothMovaText() == null || "".equals(mothMovable.getMothMovaText())){
            return new ResultMsg(false,  ResultMsg.ERROR, "未输入文字",null);
        }
        if(mothMovable.getMothMovaText().length() > 200){
            return new ResultMsg(false,  ResultMsg.ERROR, "文字超出限制",null);
        }

        MothMovable mothM = new MothMovable();
        mothM.setMothMovaOpenId(member.getUserOpenid());
        List<MothMovable>mothMovableList = mothMovableService.getMothMovableList(mothM);
        if(mothMovableList != null && mothMovableList.size() > 0 ){
            return new ResultMsg(false,  ResultMsg.ERROR, "已经生成过活动图片了，请刷新页面",null);
        }

        String realPath = request.getSession().getServletContext().getRealPath("/");

        mothMovable.setMothMovaOpenId(member.getUserOpenid());
        mothMovable.setMothMovaHead(member.getUserHead());

        String name = java.net.URLDecoder.decode( member.getUserNickname(), ENCODE);
        mothMovable.setMothMovaName(name);
        try {
            Integer falg = mothMovableService.save(mothMovable,realPath);
        }catch (Exception e){
            return new ResultMsg(false,  ResultMsg.ERROR, e.getMessage(),null);
        }
        msg.setResultCode(ResultInfo.SUCCESSCODE);
        msg.setData(mothMovable);
        msg.setStatus(true);
        long y = System.currentTimeMillis();
        System.out.println("响应时间："+ (y-x));
        return msg;
    }

    /**
     * 获取自己生成图片
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping(value = "/get_moth", method = RequestMethod.POST)
    public ResultMsg getMoth( HttpServletResponse response,HttpServletRequest request) throws Exception {
        ResultMsg msg = new ResultMsg();

        Member member = WechatUtils.getUserBySession(request);
        member = memberService.getMemberByUserOpenId(member.getUserOpenid());

        //进入活动的UV埋点
        AcceStatistics acceStatistics = new AcceStatistics();
        acceStatistics.setAcceStatOpenId(member.getUserOpenid());
        acceStatistics.setAcceStatType(1);
        acceStatistics.setJudgeTime(new Date());
        Integer count = acceStatisticsService.getAcceStatiCount(acceStatistics);
        if(count < 0){  //添加UV访问
            Integer flag = acceStatisticsService.save(acceStatistics);
        }

        MothMovable mothMovable = new MothMovable();
        mothMovable.setMothMovaOpenId(member.getUserOpenid());
        List<MothMovable>  mothMovableList = mothMovableService.getMothMovableList(mothMovable);
        if(mothMovableList == null || mothMovableList.size() < 1){  //未参与活动
            msg = new ResultMsg(false,  ResultMsg.ERROR, "未参与活动，请参与活动！",null);
            msg.setData(member);
            return msg;
        }
        mothMovable = mothMovableList.get(0);
        msg.setData(mothMovable);
        msg.setResultCode(ResultInfo.SUCCESSCODE);
        msg.setStatus(true);
        return msg;
    }

}
